package ex11;

import mylib.Util;

public class BlackJack {
	private CardDeck deck;
	private Dealer dealer;
	private Player player;
	
	public BlackJack(String dname, String pname){
		deck = new CardDeck(CARDS);
		dealer	=	new Dealer(dname, DEALER_ICON, deck);
		player	=	new Player(pname, PLAYER_ICON, deck);
	}
	public void initialize(){
		if(deck.size()<LIMIT) deck.initialize();
		dealer.initialize();
		player.initialize();
	}
	public void show(){
		System.out.println();
		System.out.println(dealer);
		System.out.println(player);
	}
	public void play(){
		String str;
		do{
			System.out.println(BANNER);
			initialize();
			showHalf();
			deal();
			dealer.over16();
			animation(TIMES, DELAY, ANIMATION_ICON);
			show();
			judge();
			
		}while((str=Util.getString(Q_CONTINUE))==null);
	}
	public void showHalf(){
		System.out.println();
		System.out.println(dealer.half());
		System.out.println(player);
	}
	public void deal(){
		while(player.score()<21){
			String str=Util.getString(Q_DEAL);
			if(str!=null)	break;
			player.addACard();
			showHalf();
		}
	}
	public void judge(){
		int d = dealer.score();
		int p = player.score();
		if(d>21&&p>21 || d==p){
			System.out.println(EVEN);
		}else if(p<=21 && (d>21||d<p)){
			System.out.println(WIN);
		}else{
			System.out.println(LOST);
		}
		
	}
	public void animation(int times, int delay, String icon){
		System.out.println();
		try {
			for(int i=0; i<times; i++){
				System.out.print(icon);
				Thread.sleep(delay);
			}
		}
		catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	static final String DEALER_ICON="";
	static final String PLAYER_ICON="";
	static final String BANNER="\n BlackJack ";
	static final int CARDS=52;
	static final String Q_CONTINUE = "܂(Enter/n)";
	static final int  LIMIT = 17;
	static final String Q_DEAL = "ɃJ[h܂(Enter/n)";
	static final String EVEN="";
	static final String WIN="Ȃ̏";
	static final String LOST="fB[[̏";
	static final String ANIMATION_ICON="";
	static final int TIMES =25;
	static final int DELAY =20;


	/*
	public static void main(String[] args) {
		BlackJack	bj	=	new BlackJack("Rs[^","vC[");
		bj.play();
	}
	*/
}
